KParts::ReadWritePart Class Referenceabstract

`#include <part.h>`

Inheritance diagram for KParts::ReadWritePart:

## Public Slots

virtual void | setModified ()
virtual bool | save ()
bool | waitSaveComplete ()
Public Slots inherited from KParts::ReadOnlyPart
virtual bool | openURL (const KURL &url)

## Signals

void | sigQueryClose (bool *handled, bool *abortClosing)
Signals inherited from KParts::ReadOnlyPart
void | started (KIO::Job *)
void | completed ()
void | completed (bool pendingAction)
void | canceled (const QString &errMsg)
Signals inherited from KParts::Part
void | setWindowCaption (const QString &caption)
void | setStatusBarText (const QString &text)

## Public Member Functions

| ReadWritePart (QObject *parent=0, const char *name=0)
virtual | ~ReadWritePart ()
bool | isReadWrite () const
virtual void | setReadWrite (bool readwrite=true)
bool | isModified () const
bool | queryClose ()
virtual bool | closeURL ()
bool | closeURL (bool promptToSave)
virtual bool | saveAs (const KURL &url)
virtual void | setModified (bool modified)
Public Member Functions inherited from KParts::ReadOnlyPart
| ReadOnlyPart (QObject *parent=0, const char *name=0)
virtual | ~ReadOnlyPart ()
void | setProgressInfoEnabled (bool show)
bool | isProgressInfoEnabled () const
void | showProgressInfo (bool show)
KURL | url () const
bool | openStream (const QString &mimeType, const KURL &url)
bool | writeStream (const QByteArray &data)
bool | closeStream ()
Public Member Functions inherited from KParts::Part
| Part (QObject *parent=0, const char *name=0)
virtual | ~Part ()
virtual void | embed (QWidget *parentWidget)
virtual QWidget * | widget ()
virtual void | setManager (PartManager *manager)
PartManager * | manager () const
virtual Part * | hitTest (QWidget *widget, const QPoint &globalPos)
virtual void | setSelectable (bool selectable)
bool | isSelectable () const
Public Member Functions inherited from KParts::PartBase
| PartBase ()
virtual | ~PartBase ()
void | setPartObject (QObject *object)
QObject * | partObject () const

## Protected Slots

void | slotUploadFinished (KIO::Job *job)
Protected Slots inherited from KParts::ReadOnlyPart
void | slotJobFinished (KIO::Job *job)

## Protected Member Functions

virtual bool | saveFile ()=0
virtual bool | saveToURL ()
Protected Member Functions inherited from KParts::ReadOnlyPart
virtual bool | openFile ()=0
void | abortLoad ()
virtual void | guiActivateEvent (GUIActivateEvent *event)
Protected Member Functions inherited from KParts::Part
virtual void | setWidget (QWidget *widget)
virtual void | customEvent (QCustomEvent *event)
virtual void | partActivateEvent (PartActivateEvent *event)
virtual void | partSelectEvent (PartSelectEvent *event)
QWidget * | hostContainer (const QString &containerName)
Protected Member Functions inherited from KParts::PartBase
virtual void | setInstance (KInstance *instance)
virtual void | setInstance (KInstance *instance, bool loadPlugins)
void | loadPlugins (QObject *parent, KXMLGUIClient *parentGUIClient, KInstance *instance)
void | setPluginLoadingMode (PluginLoadingMode loadingMode)

## Additional Inherited Members

Protected Types inherited from KParts::PartBase
enum | PluginLoadingMode { DoNotLoadPlugins = 0, LoadPlugins = 1, LoadPluginsIfEnabled = 2 }
Protected Attributes inherited from KParts::ReadOnlyPart
KURL | m_url
QString | m_file
bool | m_bTemp

## Detailed Description

Base class for an "editor" part.

This class handles network transparency for you. Anything that can open a URL, allow modifications, and save (to the same URL or a different one).

A read-write part can be set to read-only mode, using setReadWrite().

Part writers : Any part inheriting ReadWritePart should check isReadWrite() before allowing any action that modifies the part. The part probably wants to reimplement setReadWrite, disable those actions. Don't forget to call the parent setReadWrite().

Definition at line 544 of file part.h.

## Constructor & Destructor Documentation

ReadWritePart::ReadWritePart | ( | QObject * | parent = `0`,
|  | const char * | name = `0`
| ) |  |

Constructor.

See parent constructor for instructions.

Definition at line 447 of file part.cpp.

ReadWritePart::~ReadWritePart | ( |  | ) |

virtual

Destructor.

Applications using a ReadWritePart should make sure, before destroying it, to call closeURL(). In KMainWindow::queryClose(), for instance, they should allow closing only if the return value of closeURL() was true. This allows to cancel.

Definition at line 453 of file part.cpp.

## Member Function Documentation

bool ReadWritePart::closeURL | ( |  | ) |

virtual

Called when closing the current url (e.g.

document), for instance when switching to another url (note that openURL() calls it automatically in this case).

If the current URL is not fully loaded yet, aborts loading.

If isModified(), queryClose() will be called.

Returns
  false on cancel

Reimplemented from KParts::ReadOnlyPart.

Definition at line 525 of file part.cpp.

bool ReadWritePart::closeURL | ( | bool | promptToSave | ) |

Call this method instead of the above if you need control if the save prompt is shown.

For example, if you call queryClose() from KMainWindow::queryClose(), you would not want to prompt again when closing the url.

Equivalent to promptToSave ? closeURL() : ReadOnlyPart::closeURL()

Since
  3.2

Definition at line 537 of file part.cpp.

bool KParts::ReadWritePart::isModified | ( |  | ) | const

inline

Returns
  true if the document has been modified.

Definition at line 577 of file part.h.

bool KParts::ReadWritePart::isReadWrite | ( |  | ) | const

inline

Returns
  true if the part is in read-write mode

Definition at line 566 of file part.h.

bool ReadWritePart::queryClose | ( |  | ) |

If the document has been modified, ask the user to save changes.

This method is meant to be called from KMainWindow::queryClose(). It will also be called from closeURL().

Returns
  true if closeURL() can be called without the user losing important data, false if the user chooses to cancel.

Since
  3.2

Definition at line 483 of file part.cpp.

bool ReadWritePart::save | ( |  | ) |

virtual slot

Save the file in the location from which it was opened.

You can connect this to the "save" action. Calls saveFile() and saveToURL(), no need to reimplement.

Definition at line 542 of file part.cpp.

bool ReadWritePart::saveAs | ( | const KURL & | url | ) |

virtual

Save the file to a new location.

Calls save(), no need to reimplement

Definition at line 554 of file part.cpp.

virtual bool KParts::ReadWritePart::saveFile | ( |  | ) |

protected pure virtual

Save to a local file.

You need to implement it, to save to `m_file`. The framework takes care of re-uploading afterwards.

Returns
  true on success, false on failure. On failure the function should inform the user about the problem with an appropriate message box. Standard error messages can be constructed using KIO::buildErrorString() in combination with the error codes defined in kio/global.h

bool ReadWritePart::saveToURL | ( |  | ) |

protected virtual

Save the file.

Uploads the file, if `m_url` is remote. This will emit started(), and either completed() or canceled(), in case you want to provide feedback.

Returns
  true on success, false on failure.

Definition at line 607 of file part.cpp.

void ReadWritePart::setModified | ( | bool | modified | ) |

virtual

Sets the modified flag of the part.

Definition at line 467 of file part.cpp.

void ReadWritePart::setModified | ( |  | ) |

virtual slot

Call setModified() whenever the contents get modified.

This is a slot for convenience, so that you can connect it to a signal, like textChanged().

Definition at line 478 of file part.cpp.

void ReadWritePart::setReadWrite | ( | bool | readwrite = `true` | ) |

virtual

Changes the behavior of this part to readonly or readwrite.

Parameters

  readwrite | set to true to enable readwrite mode

Definition at line 461 of file part.cpp.

void KParts::ReadWritePart::sigQueryClose | ( | bool * | handled,
|  | bool * | abortClosing
| ) |  |

signal

Since
  3.2, remove in KDE 4, when queryClose is made virtual

set handled to true, if you don't want the default handling set abortClosing to true, if you handled the request, but for any reason don't want to allow closing the document

bool ReadWritePart::waitSaveComplete | ( |  | ) |

slot

Waits for any pending upload job to finish and returns whether the last save() action was successful.

Definition at line 685 of file part.cpp.

The documentation for this class was generated from the following files:

- part.h
- part.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys